-- by modelleicher
-- www.schwabenmodding.de
-- date: 21.07.2017
-- tramlines animation 

tramlines = {};

function tramlines.prerequisitesPresent(specializations)
	return SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations);
end;

function tramlines:load(savegame)
	self.setTramLines = tramlines.setTramLines;
	
	self.tramL = {};
	self.tramL.animationName = getXMLString(self.xmlFile, "vehicle.tramlines#animationName");
	if self.tramL.animationName ~= nil then
		self:setTramLines(true, true);
	end;
	self.tramL.state = true;
	
end;

function tramlines:readStream(streamId, connection)  
    self:setTramLines(streamReadBool(streamId), true);  
end;

function tramlines:writeStream(streamId, connection)  
    streamWriteBool(streamId, self.tramL.state);  
end;


function tramlines:update(dt)    
	
	if self:getIsActiveForInput() then
		if self.tramL.animationName ~= nil then
			if InputBinding.hasEvent(InputBinding.TOGGLE_TRAMLINES) then
				self:setTramLines(not self.tramL.state);
			end;
		end;
	end;

end;
function tramlines:setTramLines(state, noEventSend)
	
	setTramLinesEvent.sendEvent(self, state, noEventSend);
	if state then
		self:playAnimation(self.tramL.animationName, -1, self:getAnimationTime(self.tramL.animationName), true);
	else	
		self:playAnimation(self.tramL.animationName, 1, self:getAnimationTime(self.tramL.animationName), true);
	end;
	self.tramL.state = state;

end;
function tramlines:delete()

end;
function tramlines:onLeave()

end;
function tramlines:mouseEvent(posX, posY, isDown, isUp, button)
end;
function tramlines:keyEvent(unicode, sym, modifier, isDown)
end;
function tramlines:draw()

	if self:getIsActiveForInput() then
		if self.tramL.animationName ~= nil then
			g_currentMission:addHelpButtonText(g_i18n:getText("toggleTramlines"), InputBinding.TOGGLE_TRAMLINES); 
		end;
	end;
	
end;


setTramLinesEvent = {};
setTramLinesEvent_mt = Class(setTramLinesEvent, Event);
InitEventClass(setTramLinesEvent, "setTramLinesEvent");

function setTramLinesEvent:emptyNew()  
    local self = Event:new(setTramLinesEvent_mt );
    self.className="setTramLinesEvent";
    return self;
end;
function setTramLinesEvent:new(vehicle, state) 
    self.vehicle = vehicle;
    self.state = state;
    return self;
end;
function setTramLinesEvent:readStream(streamId, connection)  
    local id = streamReadInt32(streamId); 
    self.state = streamReadBool(streamId); 
    self.vehicle = networkGetObject(id); 
    self:run(connection);  
end;
function setTramLinesEvent:writeStream(streamId, connection)   
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));	
    streamWriteBool(streamId, self.state );   
end;
function setTramLinesEvent:run(connection) 
    self.vehicle:setTramLines(self.state, true);
	if not connection:getIsServer() then  
		g_server:broadcastEvent(setTramLinesEvent:new(self.vehicle, self.state), nil, connection, self.object);
	end;
end;
function setTramLinesEvent.sendEvent(vehicle, state, noEventSend)  
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then   
			g_server:broadcastEvent(setTramLinesEvent:new(vehicle, state), nil, nil, vehicle);
		else 
			g_client:getServerConnection():sendEvent(setTramLinesEvent:new(vehicle, state));
		end;
	end;
end;
